#!/bin/sh
########################################################################
# File:           setup/ca.sh                                          #
# myLinux Server: Copyright (c) 2003 Michael Oberg                     #
# Version:        0.92                                                 #
# Author:         Michael Oberg <michael.oberg@mylinuxproject.de>      #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License as published by #
# the Free Software Foundation; either version 2 of the License, or    #
# (at your option) any later version.                                  #
#                                                                      #
# This program is distributed in the hope that it will be useful,      #
# but WITHOUT ANY WARRANTY; without even the implied warranty of       #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         #
# GNU General Public License for more details.                         #
#                                                                      #
# You should have received a copy of the GNU Public License along      #
# with this package; if not, write to the Free Software Foundation,    #
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.       #
########################################################################
source mylinux.conf
##############################################################
# configure certificate authority                            #
##############################################################
cp -dp /etc/ssl/openssl.cnf /etc/ssl/openssl.cnf-default
cat /etc/ssl/openssl.cnf-default | sed 's|^dir\([ \t]*\)= *\./demoCA\t|dir\1= /etc/ssl/mylinux|' > /etc/ssl/openssl.cnf

CATOP=/etc/ssl/mylinux
YEAR=`date +%Y`

# creating directory structure of the certificate authority
rm -rf ${CATOP}
mkdir ${CATOP}
mkdir ${CATOP}/certs
mkdir ${CATOP}/crl
mkdir ${CATOP}/newcerts
mkdir ${CATOP}/private
chmod 700 ${CATOP}/private
echo "01" > ${CATOP}/serial
touch ${CATOP}/index.txt

# create root certificate
cat << EOF | openssl req -nodes -new -x509 -days 7300 -keyout ${CATOP}/private/cakey.pem -out ${CATOP}/cacert.pem 2> /dev/null
$COUNTRY
$STATE
$CITY
$COMPANY
Certificate Authority $YEAR
$FQHOSTNAME
root@$DOMAIN
EOF
chmod 600 ${CATOP}/private/cakey.pem

# export the public key to MS Windows (Internet Explorer, Outlook...)
openssl x509 -outform DER -in /etc/ssl/mylinux/cacert.pem -out /etc/ssl/mylinux/cacert.crt
